/*------------------------------------------------------------*/
/* filename -       tlwfield.cpp                              */
/*                                                            */
/* function(s)                                                */
/*                  TLowerField                               */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision Extensions -- Version 1.1.1                */
/*                                                            */
/*                                                            */
/*    Portions Copyright (c) 1991 by Borland International    */
/*    All Rights Reserved.                                    */
/*                                                            */
/*    TV Extensions are Copyright (c) 1992 by Michael Bonner  */
/*    These extensions may be freely used by any programmer   */
/*    including royalty free inclusion in any commercial      */
/*    application, but any commercial rights to the source    */
/*    code or object files of the Extensions are reserved.    */
/*                                                            */
/*   Thanks to Jerry Jankura CI$ 70170,306 who contributed    */
/*   the TLowerField code!.  										     */
/*------------------------------------------------------------*/

#define Uses_ipstream
#define Uses_MsgBox
#define Uses_opstream
#define Uses_TButton
#define Uses_TDeskTop
#define Uses_TDialog
#define Uses_TDrawBuffer
#define Uses_TEvent
#define Uses_TField
#define Uses_TKeys
#define Uses_TRect
#define Uses_TStaticText
#define Uses_TLowerField
#define Uses_TView

#include <tv.h>
#include "tfield.h"

#if !defined( __CTYPE_H )
#include <ctype.h>
#endif  // __CTYPE_H

#if !defined( __STRING_H )
#include <String.h>
#endif  // __STRING_H

#if !defined( __DOS_H )
#include <Dos.h>
#endif  // __DOS_H

#if !defined( __MEM_H )
#include <Mem.h>
#endif  // __MEM_H


const char * const near TLowerField :: name = "TLowerField";

TLowerField :: TLowerField (const TRect & bounds, int aMaxLen) :
  TField (bounds, aMaxLen)
{
  fieldType = TLowerFieldType;
}

inline ushort TLowerField :: filterCharCode (ushort charCode)         //Virtual
{
  return islower (charCode) ? charCode : _tolower (charCode);
}

void TLowerField :: setData (void * rec)  //Virtual
{
  memcpy (data, rec, dataSize () - 1);
  data [dataSize () - 1] = EOS;
  strlwr (data);
  selectAll (True);
}

